<template>
	<main class="p-5">
		<!-- Total Info -->
		<div class="flex flex-wrap justify-center sm:justify-between">
			<TileTotal addClass="bg-red-500 font-bold text-white">
				<p class="text-2xl mb-1">{{ totalDeath }}</p>
				<p>Total Death</p>
			</TileTotal>
			<TileTotal addClass="bg-yellow-400 font-bold">
				<p class="text-2xl mb-1">{{ totalDeath }}</p>
				<p>Total Death</p>
			</TileTotal>
			<TileTotal addClass="bg-blue-200 font-bold">
				<p class="text-2xl mb-1">{{ totalDeath }}</p>
				<p>Total Death</p>
			</TileTotal>
		</div>

		<!-- Charts -->
		<div
			class="
				flex flex-wrap
				justify
				center
				sm:justify-between
			"
		>
			<Chart
				titleChart="Death vs Positive"
				widthClass="w-full mlg:w-1/2"
				type="line"
				:options="optionsLine"
				:labels="labelsLine"
				:datasets="datasetsLine"
			/>
			<Chart
				titleChart="Death vs Positive"
				widthClass="w-full mlg:w-1/2"
				type="bar"
				:options="optionsBar"
				:labels="labelsBar"
				:datasets="datasetsBar"
			/>
			<Chart
				titleChart="Death vs Hospitalize vs Positive"
				widthClass="w-full xs:w-1/2 mlg:w-1/3 lg:w-1/4"
				type="doughnut"
				:labels="labelsDP"
				:datasets="datasetsDP"
			/>
			<Chart
				titleChart="Death vs Hospitalize vs Positive"
				widthClass="w-full xs:w-1/2 mlg:w-1/3 lg:w-1/4"
				type="pie"
				:labels="labelsDP"
				:datasets="datasetsDP"
			/>
			<Chart
				titleChart="Death vs Hospitalize vs Positive"
				widthClass="w-full xs:w-1/2 mlg:w-1/3 lg:w-1/4"
				type="polarArea"
				:labels="labelsDP"
				:datasets="datasetsDP"
			/>
			<Chart
				titleChart="Death vs Hospitalize"
				widthClass="w-full xs:w-1/2 mlg:w-1/3 lg:w-1/4"
				type="radar"
				:labels="labelsLine"
				:datasets="datasetsLine"
			/>
			<Chart
				titleChart="Death vs Hospitalize"
				widthClass="w-full mlg:w-2/3 mlg:w-1/2"
				type="bar"
				:labels="labelsMixed"
				:datasets="datasetsMixed"
			/>
		</div>
	</main>
</template>

<script>
import { computed, onMounted, ref } from "@vue/runtime-core";
import { useStore } from "vuex";
import { INITIALIZE_DATA } from "../store/actions";

import TileTotal from "./TileTotal.vue";
import Chart from "./Charts/Chart.vue";

export default {
	name: "Dashboard",
	components: {
		TileTotal,
		Chart,
	},
	setup() {
		const store = useStore();

		const dates = computed(() => store.state.dates);
		const deathIncrease = computed(() => store.state.deathIncrease);
		const positiveIncrease = computed(() => store.state.positiveIncrease);
		const totalDeath = computed(() => store.state.totalDeath);
		const totalPositive = computed(() => store.state.totalPositive);
		const totalHospitalize = computed(() => store.state.totalHospitalize);

		const labelsLine = ref(null);
		const datasetsLine = ref(null);
		const optionsLine = {
			scales: {
				y: {
					beginAtZero: true,
					ticks: {
						color: 'red',
						textStrokeColor: true,
						textStrokeWidth: 0.5
					}
				},
				x: {
					title: {
						text: "Day",
						display: true,
						color: '#000',
						font: {
							size: 15,
							weight: 'bold'
						}
					},
					ticks: {
						color: 'darkblue'
					}
				}
			},
		};

		const labelsBar = ref(null);
		const datasetsBar = ref(null);
		const optionsBar = {
			scales: {
				y: {
					beginAtZero: true,
				},
			},
		};

		const labelsDP = ref(null);
		const datasetsDP = ref(null);

		const labelsMixed = ref(null);
		const datasetsMixed = ref(null);

		onMounted(() => {
			store.dispatch(INITIALIZE_DATA);

			labelsLine.value = dates.value;
			datasetsLine.value = [
				{
					label: "Death Increase",
					data: deathIncrease.value,
					borderColor: "black",
					backgroundColor: "rgba(100, 100, 10, 0.2)",
					borderWidth: 1,
					fill: true,
				},
				{
					label: "Positive Increase",
					data: positiveIncrease.value,
					borderColor: "red",
					backgroundColor: "rgba(250, 0, 0, 0.2)",
					borderWidth: 1,
					fill: true
				},
			];

			labelsBar.value = dates.value;
			datasetsBar.value = [...datasetsLine.value]

			labelsDP.value = [
				"Total Death",
				"Total Hospitalize",
				"Total Positive"
			];
			datasetsDP.value = [
				{
					label: "Comparison",
					data: [
						totalDeath.value,
						totalHospitalize.value,
						totalPositive.value
					],
					backgroundColor: ["black", "red", "blue"],
					hoverOffset: 2,
				},
			];

			labelsMixed.value = dates.value
			datasetsMixed.value = [
				{
					label: "Death",
					data: deathIncrease.value,
					borderColor: "black",
					backgroundColor: "rgba(100, 100, 10, 0.2)",
					borderWidth: 1,
					order: 2
				},
				{
					label: "Death",
					type: 'line',
					data: deathIncrease.value,
					borderColor: "blue",
					backgroundColor: "rgba(100, 100, 10, 0.2)",
					borderWidth: 3,
					order: 3
				},
				{
					label: "Positive",
					type: 'line',
					data: positiveIncrease.value,
					borderColor: "red",
					backgroundColor: "rgba(100, 100, 10, 0.2)",
					borderWidth: 3,
					order: 1
				},
			];
		});

		return {
			totalDeath,
			labelsLine,
			datasetsLine,
			optionsLine,
			labelsBar,
			datasetsBar,
			optionsBar,
			labelsDP,
			datasetsDP,
			labelsMixed,
			datasetsMixed
		};
	},
};
</script>

<style>
</style>